import { Component, OnInit, ViewChild } from '@angular/core';
import { Router } from '@angular/router';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFSchema, SFDateWidgetSchema, SFUISchema } from '@delon/form';
import { NzMessageService } from 'ng-zorro-antd/message';
import { NzModalService } from 'ng-zorro-antd/modal';
import { TicketService } from '../../services/system.service';

@Component({
  selector: 'app-invoice-requested',
  templateUrl: './invoice-requested.component.html',
  styleUrls: ['./invoice-requested.component.less']
})
export class InvoiceRequestedComponent implements OnInit {
  url = `/rule?_allow_anonymous=true`;
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;
  @ViewChild('auditModal', { static: false })
  auditModal!: any;
  columns: STColumn[] = [
    { title: '', index: 'key', type: 'checkbox' },
    { title: '申请编号', index: 'no' },
    { title: '申请时间', index: 'updatedAt', type: 'date' },
    { title: '处理进度', index: 'callNo' },
    { title: '托运人', index: 'callNo' },
    { title: '开票方', index: 'callNo' },
    { title: '运单数', index: 'callNo' },
    { title: '开票金额', index: 'callNo' },
    { title: '发票张数', index: 'callNo' },
    { title: '收件人', index: 'callNo' },
    { title: '联系电话', index: 'callNo' },
    { title: '收件地址', index: 'callNo' },
    { title: '备注', index: 'callNo' },
    {
      title: '操作',
      buttons: [
        {
          text: '审核',
          click: item => this.auditAction(item)
        },
        {
          text: '去开票',
          click: item => this.routeTo(item)
        },
        {
          text: '查看原因',
          click: item => this.showReason(item)
        },
        {
          text: '订单明细',
          click: item => this.routeTo(item)
        }
      ]
    }
  ];
  searchSchema: SFSchema = {
    properties: {
      expand: {
        type: 'boolean',
        ui: {
          hidden: true
        }
      },
      orderSn: {
        type: 'string',
        title: '申请编号',
        ui: {
          autocomplete: 'off'
        }
      },
      createTime: {
        title: '申请时间',
        type: 'string',
        ui: {
          widget: 'date',
          mode: 'range',
          format: 'yyyy-MM-dd'
        } as SFDateWidgetSchema
      },
      receiveName: {
        type: 'string',
        title: '处理进度',
        enum: [
          { label: '全部', value: '全部' },
          { label: '企业认证审核', value: '企业认证审核' },
          { label: '企业管理员审核', value: '企业管理员审核' }
        ],
        ui: {
          widget: 'select',
          placeholder: '请选择',
          change: (i: any) => {
            this.sf.value.receiveName = i;
            this.sf?.setValue('/receiveName', i);
          }
        }
      },
      receiveName2: {
        type: 'string',
        title: '托运人',
        enum: [
          { label: '全部', value: '全部' },
          { label: '企业认证审核', value: '企业认证审核' },
          { label: '企业管理员审核', value: '企业管理员审核' }
        ],
        ui: {
          widget: 'select',
          placeholder: '请选择',
          change: (i: any) => {
            this.sf.value.receiveName2 = i;
            this.sf?.setValue('/receiveName2', i);
          },
          visibleIf: {
            expand: (value: boolean) => value
          }
        }
      },
      receiveName3: {
        type: 'string',
        title: '开票方',
        enum: [
          { label: '全部', value: '全部' },
          { label: '企业认证审核', value: '企业认证审核' },
          { label: '企业管理员审核', value: '企业管理员审核' }
        ],
        ui: {
          widget: 'select',
          placeholder: '请选择',
          change: (i: any) => {
            this.sf.value.receiveName3 = i;
            this.sf?.setValue('/receiveName3', i);
          },
          visibleIf: {
            expand: (value: boolean) => value
          }
        }
      }
    }
  };

  reqParams = {};

  _$expand = false;

  selectedRows: any[] = [];
  totalCallNo = 0;
  constructor(public service: TicketService, private nzModalService: NzModalService, private router: Router) {}

  ngOnInit(): void {}

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        this.totalCallNo = this.selectedRows.reduce((total, cv) => total + cv.callNo, 0);
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }

  approval(): void {}

  add(): void {}

  routeTo(item: any) {
    this.router.navigate(['/ticket/invoice-requested-detail/1']);
  }

  auditAction(item: any) {
    const modal = this.nzModalService.create({
      nzTitle: '审核',
      nzContent: this.auditModal,
      nzFooter: [
        {
          label: '拒绝',
          type: 'default',
          onClick: () => {
            modal.destroy();
          }
        },
        {
          label: '通过',
          type: 'primary',
          onClick: () => {
            modal.destroy();
          }
        }
      ]
    });
    modal.afterClose.subscribe(res => {
      this.st.load();
    });
  }

  showReason(item: any) {
    const modal = this.nzModalService.create({
      nzTitle: '查看原因',
      nzContent: '运单数据异常，暂时无法开票，请联系客服400-xxxx-xxxx',
      nzFooter: [
        {
          label: '关闭',
          type: 'primary',
          onClick: () => {
            modal.destroy();
          }
        }
      ]
    });
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
    this._$expand = false;
  }

  /**
   * 伸缩查询条件
   */
  expandToggle() {
    this._$expand = !this._$expand;
    this.sf?.setValue('/expand', this._$expand);
  }
}
